;	*******************************
;	*                             *
;	*          STAR-DEMO          *
;	*             von             *
;	*        Peter  Sabath        *
;	*                             *
;	*                             *
;	*  (c) Bibosoft / Compy-Shop  *
;	*                             *
;	*******************************
;
	ORG $4000
;
START	LDA #0
	STA $D40E    ;NMI SPERREN
	STA $D018    ;FARBREGISTER
	STA $D01A    ;SCHWARZ
	STA $2C6     ;SETZEN
	STA $2C8
; ------------------------------
	LDA #DLI&255
	STA $200     ;DLI-VECTOR
	LDA #DLI/256     ;VERBIEGEN
	STA $201
	LDA #VBI&255
	STA $222     ;VBI-VECTOR
	LDA #VBI/256     ;VERBIEGEN
	STA $223
; ------------------------------
	LDX #$10
SETUP	LDA $D20A   ;ZUFAELLIGE
	STA $5000,X ;STERN X-POSITION
	LDA $D20A   ;GESCHWINDIGKEIT
	AND #$3     ;FESTLEGEN
	STA $5100,X
	INC $5100,X
	LDA $D20A   ;ZUFAELLIGE
	STA $5200,X ;FARBE
	INX
	BNE SETUP
; ------------------------------
	LDA $230
	STA $0      ;DLI-START
	LDA $231    ;IN DISPAY-
	STA $1      ;LIST EIN-
	LDY #2      ;TRAGEN
	LDA #$F0
	STA ($0),Y
; ------------------------------
	LDA #$C0    ;NMI'S ZULASSEN
	STA $D40E
LOOP	JMP LOOP
; ------------------------------
;	* ENDLOSSCHLEIFE DIE AUCH  *
;	* DURCH EIN WEITERES PRO-  *
;	* GRAMM FORTGEFUERT WERDEN *
;	* KOENNTE. DES EIGENDLICHE *
;	* PROGRAMM WIRD NUR DURCH  *
;	* INTERRUPTS AUFRECHT ER-  *
;	* HALTEN.                  *
; ------------------------------
; *   DISPLAY LIST INTERRUPT   *
; ------------------------------
DLI	PHA
	TYA
	PHA
	LDA #$80    ;MISSILE 3
	STA $D011   ;SETZEN
	LDY #$D0
SETSTAR	LDA $4FFF,Y ;X-POSITION
	STA $D40A   ;SYNCRONISIEREN
	STA $D007   ;NACH PM-POSITIONSREGISTER 7 (MISSILE 3)
	LDA $51FF,Y ;FARBE IN
	STA $D015   ;HARDWARE REGISTER
	DEY
	BNE SETSTAR
	LDA #0      ;MISSILE 3
	STA $D011   ;LOESCHEN
	PLA
	TAY
	PLA
	RTI
; ------------------------------
; *  VERTICAL BLANK INTERRUPT  *
; ------------------------------
VBI	LDY #0      ;ALLE X-POSITIONEN
MOVE	LDA $5000,Y ;UM GESCHWIN-
	CLC         ;DIGKEITSWERT
	ADC $5100,Y ;ERHOEHEN
	STA $5000,Y
	DEY
	BNE MOVE
	JMP $E45F   ;SYSTEM VBI
